#include	"quasi88.h"
#include	"ini.h"
#include	"textfile.h"
#include	"keyboard.h"
#include	"pc88main.h"
#include	"soundbd.h"
#include	"memory.h"
#include	"screen.h"
#include	"emu.h"
#include	"fdc.h"
#include	"intr.h"
#include	"wait.h"
#include	"device.h"
#include	"snapshot.h"
#include	"menu.h"
#include	"pc88sub.h"
#include	"snddrv.h"
//#include	"initval.h"
//#include	"q8tk.h"
//#include	"message.h"

/*
#define str_1d  "%d"
#define str_1u  "%u"
#define str_1x  "%x"
#define str_2d  "%.2d"
#define str_2x  "%.2x"
#define str_4x  "%.4x"
#define str_4X  "%.4X"
#define str_false  "false"
#define str_true "true"
*/
const char str_clock[] = "%8.4f";
const char str_1d[] = "%d";
const char str_1u[] = "%u";
const char str_1x[] = "%x";
const char str_1f[] = "%f";
const char str_2d[] = "%.2d";
const char str_2x[] = "%.2x";
const char str_4x[] = "%.4x";
const char str_4X[] = "%.4X";

const char str_false[] = "false";
const char str_true[] = "true";

QUASI88CFG quasi88cfg = 
	{0, 27, 122, 120, 32, 13, 274, 273, 276, 275, 304, 303,
	-1, 1, 0, 0, 0x391a,
	-1, 0, 0, 
	1, 0, 
	0, 4000, 5, 0,
	3.9936,
	100, 0, 1, 
	0, 1, 0, 0, 0,
	1, 1600, 3.9936*16, 16,
	1, 1, 1,
	1, 0, 1,
	0, 1, 1, 0x000000,
	0, 0, 0,
	0, 0, 1, 0, 0,
	1, 0, 1, 100,
	0, 55.4, 3.9936,
	6, 0,
	0, 0,
	100, 20, 60, 100, 100
	};

void ini_read(const char *path, const char *title,
											const INITBL *tbl, UINT count);
void ini_write(const char *path, const char *title,
											const INITBL *tbl, UINT count);

void initload(void);
void initsave(void);

FILE *file_create(const char *path);
long file_seek(FILE *handle, long pointer, int method);
UINT file_read(FILE *handle, void *data, UINT length); 
UINT file_write(FILE *handle, const void *data, UINT length);
short file_close(FILE *handle);
FILE *file_open_rb(const char *path);

#ifdef __cplusplus
}
#endif


struct _textfile;
typedef struct _textfile                _TEXTFILE;
typedef struct _textfile                *TEXTFILE;

typedef UINT (*READFN)(TEXTFILE tf, void *buffer, UINT size);


typedef struct {
const char		*title;
const INITBL	*tbl;
const INITBL	*tblterm;
	UINT		count;
} _INIARG, *INIARG;

FILE *file_create(const char *path) {

        return(fopen(path, "wb+"));
}

long file_seek(FILE *handle, long pointer, int method) {

        fseek(handle, pointer, method);
        return(ftell(handle));
}

UINT file_read(FILE *handle, void *data, UINT length) {

        return((UINT)fread(data, 1, length, handle));
}

UINT file_write(FILE *handle, const void *data, UINT length) {

        return((UINT)fwrite(data, 1, length, handle));
}

short file_close(FILE *handle) {

        fclose(handle);
        return(0);
}

FILE *file_open_rb(const char *path) {
        return(fopen(path, "rb+"));
}

static void strdelspace(char **buf, int *size) {

        char *p;
        int             len;

        p = *buf;
        len = *size;
        while((len > 0) && (p[0] == ' ')) {
                p++;
                len--;
        }
        while((len > 0) && (p[len - 1] == ' ')) {
                len--;
        }
        *buf = p;
        *size = len;
}

static char *profana(char *buf, char **data) {

        int             len;
        char	*buf2;
        int             l;

        len = strlen(buf);
        strdelspace(&buf, &len);
        if ((len >= 2) && (buf[0] == '[') && (buf[len - 1] == ']')) {
                buf++;
                len -= 2;
                strdelspace(&buf, &len);
                buf[len] = '\0';
                *data = NULL;
                return(buf);
        }
        for (l=0; l<len; l++) {
                if (buf[l] == '=') {
                        break;
                }
        }
        if (l < len) {
                len -= (l + 1);
                buf2 = buf + (l + 1);
                strdelspace(&buf, &l);
                buf[l] = '\0';
                strdelspace(&buf2, &len);
                if ((len >= 2) && (buf2[0] == '\"') && (buf2[len - 1] == '\"')) {
                        buf2++;
                        len -= 2;
                        strdelspace(&buf2, &len);
                }
                buf2[len] = '\0';
                *data = buf2;
                return(buf);
        }
	return(NULL);
}

BOOL profile_enum(const char *filename, void *arg, BOOL (*proc)(void *arg,
const char *para, const char *key, const char *data)) {
        //TEXTFILEH       fh;
        void	*fh;
        BOOL            r;
        char	buf[0x200];
        char	para[0x100];
        char	*key;
        char	*data;

        r = FALSE;
        if (proc == NULL) {
                goto gden_err0;
        }
        fh = textfile_open(filename, 0x800);
        if (fh == NULL) {
                goto gden_err0;
        }
        para[0] = '\0';
        while(1) {
                if (textfile_read(fh, buf, NELEMENTS(buf)) != SUCCESS) {
                        break;
                }
                key = profana(buf, &data);
                if (key) {
                        if (data == NULL) {
                                strncpy(para, key, NELEMENTS(para));
                        }
                        else {
                                r = proc(arg, para, key, data);
                                if (r != SUCCESS) {
                                        break;
                                }
                        }
                }
        }
        textfile_close(fh);

gden_err0:
        return(r);
}


long milstr_solveHEX(const char *str) {

        long    ret;
        int             i;
        char c;

        ret = 0;
        for (i=0; i<8; i++) {
                c = *str++;
                if ((c >= '0') && (c <= '9')) {
                        c -= '0';
                }
                else if ((c >= 'A') && (c <= 'F')) {
                        c -= '7';
                }
                else if ((c >= 'a') && (c <= 'f')) {
                        c -= 'W';
                }
                else {
                        break;
                }
                ret <<= 4;
                ret += (long)c;
        }
        return(ret);
}

long milstr_solveINT(const char *str) {

        unsigned long   ret;
        BOOL                    minus;
        int                             c;

        ret = 0;
        minus = FALSE;
        c = *str;
        if (c == '+') {
                str++;
        }
        else if (c == '-') {
                str++;
                minus = TRUE;
        }
        while(1) {
                c = *str++;
                c -= '0';
                if ((c >= 0) && (c < 10)) {
                        ret *= 10;
                        ret += c;
                }
                else {
                        break;
                }
        }
        if (!minus) {
                return((long)ret);
        }
        else {
                return((long)(0 - ret));
        }
}

static void inirdarg8(BYTE *dst, int dsize, const char *src) {

	int		i;
	BYTE	val;
	BOOL	set;
	char	c;

	for (i=0; i<dsize; i++) {
		val = 0;
		set = FALSE;
		while(*src == ' ') {
			src++;
		}
		while(1) {
			c = *src;
			if ((c == '\0') || (c == ' ')) {
				break;
			}
			else if ((c >= '0') && (c <= '9')) {
				val <<= 4;
				val += c - '0';
				set = TRUE;
			}
			else {
				c |= 0x20;
				if ((c >= 'a') && (c <= 'f')) {
					val <<= 4;
					val += c - 'a' + 10;
					set = TRUE;
				}
			}
			src++;
		}
		if (set == FALSE) {
			break;
		}
		dst[i] = val;
	}
}

static BOOL inireadcb(void *arg, const char *para,
										const char *key, const char *data) {

const INITBL	*p;

	if (arg == NULL) {
		return(FAILURE);
	}
	if (strcmp(para, ((INIARG)arg)->title)) {
		return(SUCCESS);
	}
	p = ((INIARG)arg)->tbl;
	while(p < ((INIARG)arg)->tblterm) {
		if (!strcmp(key, p->item)) {
			switch(p->itemtype) {
				case INITYPE_STR:
					strncpy((char *)p->value, data, p->size);
					break;

				case INITYPE_BOOL:
					*((BYTE *)p->value) = (!strcmp(data, str_true))?1:0;
					break;

				case INITYPE_BYTEARG:
					inirdarg8((BYTE *)p->value, p->size, data);
					break;

				case INITYPE_SINT8:
				case INITYPE_UINT8:
					*((BYTE *)p->value) = (BYTE)milstr_solveINT(data);
					break;

				case INITYPE_SINT16:
				case INITYPE_UINT16:
					*((UINT16 *)p->value) = (UINT16)milstr_solveINT(data);
					break;

				case INITYPE_SINT32:
				case INITYPE_UINT32:
					*((UINT32 *)p->value) = (UINT32)milstr_solveINT(data);
					break;

				case INITYPE_HEX8:
					*((BYTE *)p->value) = (BYTE)milstr_solveHEX(data);
					break;

				case INITYPE_HEX16:
					*((UINT16 *)p->value) = (UINT16)milstr_solveHEX(data);
					break;

				case INITYPE_HEX32:
					*((UINT32 *)p->value) = (UINT32)milstr_solveHEX(data);
					break;

				case INITYPE_DOUBLE:
					*((double *)p->value) = (double)atof(data);
					break;
				case INITYPE_CLOCK:
					*((double *)p->value) = (double)atof(data);
					break;
			}
		}
		p++;
	}
	return(SUCCESS);
}

void ini_read(const char *path, const char *title,
											const INITBL *tbl, UINT count) {

	_INIARG	iniarg;

	if (path == NULL) {
		return;
	}
	iniarg.title = title;
	iniarg.tbl = tbl;
	iniarg.tblterm = tbl + count;
	profile_enum(path, &iniarg, inireadcb);
}


// ----

static void iniwrsetstr(char *work, int size, const char *ptr) {

	int		i;
	char	c;

	if (ptr[0] == ' ') {
		goto iwss_extend;
		
	}
	i = strlen(ptr);
	if ((i) && (ptr[i-1] == ' ')) {
		goto iwss_extend;
	}
	while(i > 0) {
		i--;
		if (ptr[i] == '\"') {
			goto iwss_extend;
		}
	}
	strncpy(work, ptr, size);
	return;

iwss_extend:
	if (size > 3) {
		size -= 3;
		*work++ = '\"';
		while(size > 0) {
			size--;
			c = *ptr++;
			if (c == '\"') {
				if (size > 0) {
					size--;
					work[0] = c;
					work[1] = c;
					work += 2;
				}
			}
			else {
				*work++ = c;
			}
		}
		work[0] = '\"';
		work[1] = '\0';
	}
}

static void iniwrsetarg8(char *work, int size, const BYTE *ptr, int arg) {

	int		i;
	char	tmp[8];

	if (arg > 0) {
		sprintf(tmp, "%.2x", ptr[0]);
		strncpy(work, tmp, size);
	}
	for (i=1; i<arg; i++) {
		sprintf(tmp, " %.2x", ptr[i]);
		strncat(work, tmp, size);
	}
}

void ini_write(const char *path, const char *title,
											const INITBL *tbl, UINT count) {

	FILEH		fh;
const INITBL	*p;
const INITBL	*pterm;
	BOOL		set;
	char		work[512];

	fh = file_create(path);
	if (fh == FILEH_INVALID) {
		return;
	}
	strncpy(work, "[", sizeof(work));
	strncat(work, title, sizeof(work));
	strncat(work, "]\r\n", sizeof(work));
	file_write(fh, work, strlen(work));

	p = tbl;
	pterm = tbl + count;
	while(p < pterm) {
		work[0] = '\0';
		set = SUCCESS;
		switch(p->itemtype) {
			case INITYPE_STR:
				iniwrsetstr(work, sizeof(work), (char *)p->value);
				break;

			case INITYPE_BOOL:
				strncpy(work, (*((BYTE *)p->value))?str_true:str_false,
																sizeof(work));
				break;

			case INITYPE_BYTEARG:
				iniwrsetarg8(work, sizeof(work), (BYTE *)p->value, p->size);
				break;

			case INITYPE_SINT8:
				sprintf(work, str_1d, *((char *)p->value));
				break;

			case INITYPE_SINT16:
				sprintf(work, str_1d, *((SINT16 *)p->value));
				break;

			case INITYPE_SINT32:
				sprintf(work, str_1d, *((SINT32 *)p->value));
				break;

			case INITYPE_UINT8:
				sprintf(work, str_1u, *((BYTE *)p->value));
				break;

			case INITYPE_UINT16:
				sprintf(work, str_1u, *((UINT16 *)p->value));
				break;

			case INITYPE_UINT32:
				sprintf(work, str_1u, *((UINT32 *)p->value));
				break;

			case INITYPE_HEX8:
				sprintf(work, str_1x, *((BYTE *)p->value));
				break;

			case INITYPE_HEX16:
				sprintf(work, str_1x, *((UINT16 *)p->value));
				break;

			case INITYPE_HEX32:
				sprintf(work, str_1x, *((UINT32 *)p->value));
				break;

			case INITYPE_DOUBLE:
				sprintf(work, str_1f, *((double *)p->value));
				break;

			case INITYPE_CLOCK:
				sprintf(work, str_clock, *((double *)p->value));
				break;

			default:
				set = FAILURE;
				break;
		}
		if (set == SUCCESS) {
			file_write(fh, p->item, strlen(p->item));
			file_write(fh, "=", 1);
			file_write(fh, work, strlen(work));
			file_write(fh, "\r\n", 2);
		}
		p++;
	}
	file_close(fh);
}


// ----

static const char ini_title[] = "QUASI88";
static const char inifile[] = "rc/quasi88.cfg";

static const INITBL iniitem[] = {
        {"wpad_button_a", INITYPE_UINT32, &quasi88cfg.wpad_button_a,        0},
        {"wpad_button_b", INITYPE_UINT32, &quasi88cfg.wpad_button_b,        27},
        {"wpad_button_plus", INITYPE_UINT32, &quasi88cfg.wpad_button_plus,  122},
        {"wpad_button_minus", INITYPE_UINT32, &quasi88cfg.wpad_button_minus, 120},
        {"wpad_button_1", INITYPE_UINT32, &quasi88cfg.wpad_button_1,        32},
        {"wpad_button_2", INITYPE_UINT32, &quasi88cfg.wpad_button_2,        13},
        {"wpad_button_left", INITYPE_UINT32, &quasi88cfg.wpad_button_left,  274},
        {"wpad_button_right", INITYPE_UINT32, &quasi88cfg.wpad_button_right, 273},
        {"wpad_button_up", INITYPE_UINT32, &quasi88cfg.wpad_button_up,      276},
        {"wpad_button_down", INITYPE_UINT32, &quasi88cfg.wpad_button_down,  275},
        {"wpad_button_fleft", INITYPE_UINT32, &quasi88cfg.wpad_button_fleft,  304},
        {"wpad_button_fright", INITYPE_UINT32, &quasi88cfg.wpad_button_fright,  303},
        {"boot_basic", INITYPE_SINT8, &quasi88cfg.boot_basic,  -1},
        {"boot_clock_4mhz", INITYPE_UINT8, &quasi88cfg.boot_clock_4mhz,  1},
        {"sound_board", INITYPE_UINT8, &quasi88cfg.sound_board,  0},
        {"use_pcg", INITYPE_UINT8, &quasi88cfg.use_pcg,  0},
        {"boot_dipsw", INITYPE_UINT32, &quasi88cfg.boot_dipsw,  0x391a},
        {"boot_from_rom", INITYPE_SINT8, &quasi88cfg.boot_from_rom,  -1},
        {"use_extram", INITYPE_UINT8, &quasi88cfg.use_extram,  0},
        {"use_jisho_rom", INITYPE_UINT8, &quasi88cfg.use_jisho_rom,  0},
        {"monitor_analog", INITYPE_UINT8, &quasi88cfg.monitor_analog, 1},
        {"cpu_timing", INITYPE_UINT8, &quasi88cfg.cpu_timing, 0},
        {"CPU_1_COUNT", INITYPE_UINT32, &quasi88cfg.CPU_1_COUNT, 4000},
        {"cpu_slice_us", INITYPE_UINT32, &quasi88cfg.cpu_slice_us, 5},
        {"fdc_wait", INITYPE_UINT8, &quasi88cfg.fdc_wait, 0},
        //{"cpu_clock_mhz", INITYPE_DOUBLE, &quasi88cfg.cpu_clock_mhz, 3.9936},
        {"cpu_clock_mhz", INITYPE_CLOCK, &quasi88cfg.cpu_clock_mhz, 3.9936},
        {"wait_rate", INITYPE_UINT32, &quasi88cfg.wait_rate, 100},
        {"no_wait", INITYPE_UINT8, &quasi88cfg.no_wait, 0},
        {"cmt_intr", INITYPE_UINT8, &quasi88cfg.cmt_intr, 1},
        {"cmt_speed", INITYPE_UINT32, &quasi88cfg.cmt_intr, 0},
        {"cmt_wait", INITYPE_UINT8, &quasi88cfg.cmt_wait, 1},
        {"highspeed_mode", INITYPE_UINT8, &quasi88cfg.highspeed_mode, 0},
        {"memory_wait", INITYPE_UINT8, &quasi88cfg.memory_wait, 0},
//        {"set_version", INITYPE_UINT8, &quasi88cfg.set_version, 0},
        {"disk_exchange", INITYPE_UINT8, &quasi88cfg.disk_exchange, 0},
        {"boost", INITYPE_UINT8, &quasi88cfg.boost, 1},
        {"fn_max_speed", INITYPE_UINT32, &quasi88cfg.fn_max_speed,  1600},
        {"fn_max_clock", INITYPE_DOUBLE, &quasi88cfg.fn_max_clock,  3.9936*16},
        {"fn_max_boost", INITYPE_UINT8, &quasi88cfg.fn_max_boost,  16},
        {"frameskip_rate", INITYPE_UINT32, &quasi88cfg.frameskip_rate,  1},
        {"use_auto_skip", INITYPE_UINT32, &quasi88cfg.use_auto_skip,  1},
        {"screen_size", INITYPE_UINT8, &quasi88cfg.screen_size,  1},
//        {"WIDTH", INITYPE_UINT8, &quasi88cfg.set_version,  0},
//        {"HEIGHT", INITYPE_UINT8, &quasi88cfg.set_version,  0},
        {"use_half_interp", INITYPE_UINT8, &quasi88cfg.use_half_interp,  1},
        {"use_interlace", INITYPE_SINT8, &quasi88cfg.use_interlace,  0},
        {"use_fullscreen", INITYPE_UINT8, &quasi88cfg.use_fullscreen,  1},
        {"hide_mouse", INITYPE_UINT8, &quasi88cfg.hide_mouse,  0},
        {"grab_mouse", INITYPE_UINT8, &quasi88cfg.grab_mouse,  1},
        {"show_status", INITYPE_UINT8, &quasi88cfg.show_status,  1},
        {"status_fg", INITYPE_UINT32, &quasi88cfg.status_fg,  0x000000},
        {"tenkey_emu", INITYPE_UINT8, &quasi88cfg.tenkey_emu,  0},
        {"cursor_key_mode", INITYPE_UINT8, &quasi88cfg.cursor_key_mode,  0},
        {"numlock_emu", INITYPE_UINT8, &quasi88cfg.numlock_emu,  0},
        {"romaji_type", INITYPE_UINT8, &quasi88cfg.romaji_type,  0},
        {"joy_swap_button", INITYPE_UINT8, &quasi88cfg.joy_swap_button,  0},
        {"keyboard_type", INITYPE_UINT8, &quasi88cfg.keyboard_type,  1},
//        {"file_keyboard", INITYPE_UINT8, &quasi88cfg.keyboard_type,  1},
        {"snapshot_format", INITYPE_UINT8, &quasi88cfg.snapshot_format,  0},
        {"menu_swapdrv", INITYPE_UINT8, &quasi88cfg.menu_swapdrv,  0},
//        {"load_config", INITYPE_UINT8, &quasi88cfg.keyboard_type,  1},
//        {"file_compatrom", INITYPE_UINT8, &quasi88cfg.keyboard_type,  1},
//        {"file_rec", INITYPE_UINT8, &quasi88cfg.keyboard_type,  1},
//        {"file_pb", INITYPE_UINT8, &quasi88cfg.keyboard_type,  1},
        {"use_joydevice", INITYPE_UINT8, &quasi88cfg.use_joydevice,  1},
        {"need_focus", INITYPE_UINT8, &quasi88cfg.need_focus,  0},
        {"wait_by_sleep", INITYPE_UINT8, &quasi88cfg.wait_by_sleep,  1},
        {"wait_sleep_min_us", INITYPE_UINT32, &quasi88cfg.wait_by_sleep,  100},
        {"calendar_stop", INITYPE_UINT8, &quasi88cfg.calendar_stop,  0},
        {"vsync_freq_hz", INITYPE_DOUBLE, &quasi88cfg.vsync_freq_hz, 55.4},
        {"sound_clock_mhz", INITYPE_DOUBLE, &quasi88cfg.sound_clock_mhz, 3.9936},
        {"sub_load_rate", INITYPE_UINT32, &quasi88cfg.sub_load_rate,  6},
        {"use_built_in_font", INITYPE_UINT8, &quasi88cfg.use_built_in_font, 0},
        {"mouse_mode", INITYPE_UINT8, &quasi88cfg.mouse_mode, 0},
        {"use_fmgen", INITYPE_UINT8, &quasi88cfg.use_fmgen, 0},
//        {"vol_total", INITYPE_UINT8, &quasi88cfg.vol_total, 0}
        {"vol_fm", INITYPE_UINT8, &quasi88cfg.vol_fm, 100},
        {"vol_psg", INITYPE_UINT8, &quasi88cfg.vol_psg, 20},
        {"vol_beep", INITYPE_UINT8, &quasi88cfg.vol_beep, 60},
        {"vol_rhythm", INITYPE_UINT8, &quasi88cfg.vol_rhythm, 100},
        {"vol_adpcm", INITYPE_UINT8, &quasi88cfg.vol_adpcm, 100},
//        {"vol_fmpsg", INITYPE_UINT8, &quasi88cfg.vol_fmpsg, 20}
};

#define	INIITEMS	(sizeof(iniitem) / sizeof(INITBL))


void initload(void) {

	char	path[MAX_PATH];
	char	buf[16];

#ifndef GEKKO
	milstr_ncpy(path, file_getcd(inifile), sizeof(path));
#else
	strncpy(path, datadir, sizeof(path));
	strncat(path, inifile, sizeof(path));
#endif
	ini_read(path, ini_title, iniitem, INIITEMS);

	boot_basic = quasi88cfg.boot_basic;
	boot_clock_4mhz = quasi88cfg.boot_clock_4mhz;
	sound_board = quasi88cfg.sound_board;
	use_pcg = quasi88cfg.use_pcg;
	boot_dipsw = quasi88cfg.boot_dipsw;
	boot_from_rom = quasi88cfg.boot_from_rom;
	use_extram = quasi88cfg.use_extram;
	use_jisho_rom = quasi88cfg.use_jisho_rom;
	monitor_analog = quasi88cfg.monitor_analog;
	monitor_15k = quasi88cfg.monitor_15k;
	cpu_timing = quasi88cfg.cpu_timing;
	CPU_1_COUNT = quasi88cfg.CPU_1_COUNT;
	cpu_slice_us = quasi88cfg.cpu_slice_us;
	fdc_wait = quasi88cfg.fdc_wait;
	cpu_clock_mhz = quasi88cfg.cpu_clock_mhz;
	//  sprintf(buf, "%8.4f", quasi88cfg.cpu_clock_mhz);
	//  q8tk_combo_set_text( widget, buf);
	wait_rate = quasi88cfg.wait_rate;
	no_wait = quasi88cfg.no_wait;
	cmt_intr = quasi88cfg.cmt_intr;
	cmt_speed = quasi88cfg.cmt_speed;
	cmt_wait = quasi88cfg.cmt_wait;
	highspeed_mode = quasi88cfg.highspeed_mode;
	memory_wait = quasi88cfg.memory_wait;
	disk_exchange = quasi88cfg.disk_exchange;
	boost = quasi88cfg.boost;
	fn_max_speed = quasi88cfg.fn_max_speed;
	fn_max_clock = quasi88cfg.fn_max_clock;
	fn_max_boost = quasi88cfg.fn_max_boost;
	frameskip_rate = quasi88cfg.frameskip_rate;
	use_auto_skip = quasi88cfg.use_auto_skip;
	screen_size = quasi88cfg.screen_size;
	use_half_interp = quasi88cfg.use_half_interp;
	use_interlace = quasi88cfg.use_interlace;
	use_fullscreen = quasi88cfg.use_fullscreen;
	hide_mouse = quasi88cfg.hide_mouse;
	grab_mouse = quasi88cfg.grab_mouse;
	show_status = quasi88cfg.show_status;
	status_fg = quasi88cfg.status_fg;
	tenkey_emu = quasi88cfg.tenkey_emu;
	cursor_key_mode = quasi88cfg.cursor_key_mode;
	numlock_emu = quasi88cfg.numlock_emu;
	romaji_type = quasi88cfg.romaji_type;
	joy_swap_button = quasi88cfg.joy_swap_button;
	keyboard_type = quasi88cfg.keyboard_type;
	snapshot_format = quasi88cfg.snapshot_format;
	menu_swapdrv = quasi88cfg.menu_swapdrv;
	use_joydevice = quasi88cfg.use_joydevice;
	need_focus = quasi88cfg.need_focus;
	wait_by_sleep = quasi88cfg.wait_by_sleep;
	wait_sleep_min_us = quasi88cfg.wait_sleep_min_us;
	calendar_stop = quasi88cfg.calendar_stop;
	vsync_freq_hz = quasi88cfg.vsync_freq_hz;
	sound_clock_mhz = quasi88cfg.sound_clock_mhz;
	sub_load_rate = quasi88cfg.sub_load_rate;
	use_built_in_font = quasi88cfg.use_built_in_font;
	mouse_mode = quasi88cfg.mouse_mode;
	use_fmgen = quasi88cfg.use_fmgen;
	//xmame_set_sound_volume(quasi88cfg.vol_total);
	xmame_set_mixer_volume(XMAME_MIXER_FM, quasi88cfg.vol_fm);
	xmame_set_mixer_volume(XMAME_MIXER_PSG, quasi88cfg.vol_psg);
	xmame_set_mixer_volume(XMAME_MIXER_BEEP, quasi88cfg.vol_beep);
	xmame_set_mixer_volume(XMAME_MIXER_RHYTHM, quasi88cfg.vol_rhythm);
	xmame_set_mixer_volume(XMAME_MIXER_ADPCM, quasi88cfg.vol_adpcm);
	//xmame_set_mixer_volume(XMAME_MIXER_FMPSG, quasi88cfg.vol_fmpsg);
}

void initsave(void) {

	char	path[MAX_PATH];

	quasi88cfg.boot_basic = boot_basic;
	quasi88cfg.boot_clock_4mhz = boot_clock_4mhz;
	quasi88cfg.sound_board = sound_board;
	quasi88cfg.use_pcg = use_pcg;
	quasi88cfg.boot_dipsw = boot_dipsw;
	quasi88cfg.boot_from_rom = boot_from_rom;
	quasi88cfg.use_extram = use_extram;
	quasi88cfg.use_jisho_rom = use_jisho_rom;
	quasi88cfg.monitor_analog = monitor_analog;
	quasi88cfg.monitor_15k = monitor_15k;
	quasi88cfg.cpu_timing = cpu_timing;
	quasi88cfg.CPU_1_COUNT = CPU_1_COUNT;
	quasi88cfg.cpu_slice_us = cpu_slice_us;
	quasi88cfg.fdc_wait = fdc_wait;
	quasi88cfg.cpu_clock_mhz = cpu_clock_mhz;
	quasi88cfg.wait_rate = wait_rate;
	quasi88cfg.no_wait = no_wait;
	quasi88cfg.cmt_intr = cmt_intr;
	quasi88cfg.cmt_speed = cmt_speed;
	quasi88cfg.cmt_wait = cmt_wait;
	quasi88cfg.highspeed_mode = highspeed_mode;
	quasi88cfg.memory_wait = memory_wait;
	quasi88cfg.disk_exchange = disk_exchange;
	quasi88cfg.boost = boost;
	quasi88cfg.fn_max_speed = fn_max_speed;
	quasi88cfg.fn_max_clock = fn_max_clock;
	quasi88cfg.fn_max_boost = fn_max_boost;
	quasi88cfg.frameskip_rate = frameskip_rate;
	quasi88cfg.use_auto_skip = use_auto_skip;
	quasi88cfg.screen_size = screen_size;
	quasi88cfg.use_half_interp = use_half_interp;
	quasi88cfg.use_interlace = use_interlace;
	quasi88cfg.use_fullscreen = use_fullscreen;
	quasi88cfg.hide_mouse = hide_mouse;
	quasi88cfg.grab_mouse = grab_mouse;
	quasi88cfg.show_status = show_status;
	quasi88cfg.status_fg = status_fg;
	quasi88cfg.tenkey_emu = tenkey_emu;
	quasi88cfg.cursor_key_mode = cursor_key_mode;
	quasi88cfg.numlock_emu = numlock_emu;
	quasi88cfg.romaji_type = romaji_type;
	quasi88cfg.joy_swap_button = joy_swap_button;
	quasi88cfg.keyboard_type = keyboard_type;
	quasi88cfg.snapshot_format = snapshot_format;
	quasi88cfg.menu_swapdrv = menu_swapdrv;
	quasi88cfg.use_joydevice = use_joydevice;
	quasi88cfg.need_focus = need_focus;
	quasi88cfg.wait_by_sleep = wait_by_sleep;
	quasi88cfg.wait_sleep_min_us = wait_sleep_min_us;
	quasi88cfg.calendar_stop = calendar_stop;
	quasi88cfg.vsync_freq_hz = vsync_freq_hz;
	quasi88cfg.sound_clock_mhz = sound_clock_mhz;
	quasi88cfg.sub_load_rate = sub_load_rate;
	quasi88cfg.use_built_in_font = use_built_in_font;
	quasi88cfg.mouse_mode = mouse_mode;
	quasi88cfg.use_fmgen = use_fmgen;
	//quasi88cfg.vol_total= xmame_get_sound_volume();
	quasi88cfg.vol_fm = xmame_get_mixer_volume(XMAME_MIXER_FM);
	quasi88cfg.vol_psg = xmame_get_mixer_volume(XMAME_MIXER_PSG);
	quasi88cfg.vol_beep = xmame_get_mixer_volume(XMAME_MIXER_BEEP);
	quasi88cfg.vol_rhythm = xmame_get_mixer_volume(XMAME_MIXER_RHYTHM);
	quasi88cfg.vol_adpcm = xmame_get_mixer_volume(XMAME_MIXER_ADPCM);
	//quasi88cfg.vol_fmpsg = xmame_get_mixer_volume(XMAME_MIXER_FMPSG);

#ifndef GEKKO
	milstr_ncpy(path, file_getcd(inifile), sizeof(path));
#else
	strncpy(path, datadir, sizeof(path));
	strncat(path, inifile, sizeof(path));
#endif
	ini_write(path, ini_title, iniitem, INIITEMS);
}

