#ifndef SCREEN_H_INCLUDED
#define SCREEN_H_INCLUDED


/*
 *	PC-88 Related
 */

typedef struct{
  unsigned	char	blue;			/* BʋPx (0`7)	*/
  unsigned	char	red;			/* RʋPx (0`7)	*/
  unsigned 	char	green;			/* GʋPx (0`7)	*/
  unsigned 	char	padding;
} PC88_PALETTE_T;

extern	PC88_PALETTE_T	vram_bg_palette;	/* wipbg	*/
extern	PC88_PALETTE_T	vram_palette[8];	/* epbg	*/

extern	byte	sys_ctrl;		/* OUT[30] SystemCtrl     	*/
extern	byte	grph_ctrl;		/* OUT[31] GraphCtrl      	*/
extern	byte	grph_pile;		/* OUT[53] dˍ킹     	*/

#define	SYS_CTRL_80		(0x01)		/* TEXT COLUMN80 / COLUMN40*/
#define	SYS_CTRL_MONO		(0x02)		/* TEXT MONO     / COLOR   */

#define	GRPH_CTRL_200		(0x01)		/* VRAM-MONO 200 / 400 line*/
#define	GRPH_CTRL_64RAM		(0x02)		/* RAM   64K-RAM / ROM-RAM */
#define	GRPH_CTRL_N		(0x04)		/* BASIC       N / N88     */
#define GRPH_CTRL_VDISP		(0x08)		/* VRAM  DISPLAY / UNDISP  */
#define GRPH_CTRL_COLOR		(0x10)		/* VRAM  COLOR   / MONO    */
#define	GRPH_CTRL_25		(0x20)		/* TEXT  LINE25  / LINE20  */

#define	GRPH_PILE_TEXT		(0x01)		/* dˍ킹 \ TEXT  */
#define	GRPH_PILE_BLUE		(0x02)		/*		       B   */
#define	GRPH_PILE_RED		(0x04)		/*		       R   */
#define	GRPH_PILE_GREEN		(0x08)		/*		       G   */



/*
 *	`揈p[N
 */

	/* `捷Ǘ */

extern	char	screen_update[ 0x4000*2 ];	/* ʕ\XVtO */
extern	int	screen_update_force;		/* ʋXVtO	  */
extern	int	screen_update_palette;		/* pbgXVtO	  */

#define	set_screen_update( x )		screen_update[x] = 1
#define	set_screen_update_force()	screen_update_force = TRUE
#define	set_screen_update_palette()	do{				\
					  screen_update_palette = TRUE;	\
					  screen_update_force = TRUE;	\
					}while(0)


	/* eLXg */

extern	int	text_attr_flipflop;
extern	Ushort	text_attr_buf[2][2048];


	/* ̑ */

extern	int	frameskip_rate;		/* ʕ\̍XVԊu		*/
extern	int	monitor_analog;		/* AiOj^[		*/

extern	int	use_auto_skip;		/* I[gt[XLbvgp */
extern	int	do_skip_draw;		/* XN[ւ̕`XLbv */
extern	int	already_skip_draw; 	/* XLbv		    */



/*
 *	\foCXp[N
 */


extern	int	have_mouse_cursor;	/* }EXJ[\邩ǂ	*/
extern	int	hide_mouse;		/* }EXBǂ		*/
extern	int	grab_mouse;		/* Ou邩ǂ		*/

extern	int	use_interlace;		/* C^[[X\		*/
extern	int	use_half_interp;	/* ʃTCYAFԂ */


enum {					/* ʃTCY			*/
  SCREEN_SIZE_HALF,			/*		320 x 200	*/
  SCREEN_SIZE_FULL,			/*		640 x 400	*/
#ifdef	SUPPORT_DOUBLE
  SCREEN_SIZE_DOUBLE,			/*		1280x 800	*/
#endif
  SCREEN_SIZE_END
};

typedef	struct{				/* ʃTCỸXg		*/
  int	w,  h;
  int	dw, dh;
} SCREEN_SIZE_TABLE;

extern const SCREEN_SIZE_TABLE screen_size_tbl[ SCREEN_SIZE_END ];

#define	STATUS_HEIGHT	(20)


extern	int	screen_size;		/* ʃTCYw		*/
extern	int	screen_size_max;
extern	int	use_fullscreen;		/* Sʕ\w		*/

extern	int	WIDTH;			/* `obt@TCY		*/
extern	int	HEIGHT;			/* `obt@cTCY		*/
extern	int	DEPTH;			/* Frbg	(8/16/32)	*/
extern	int	SCREEN_W;		/* ʉTCY (320/640/1280)	*/
extern	int	SCREEN_H;		/* ʏcTCY (200/400/800)	*/

extern	char	*screen_buf;		/* `obt@擪		*/
extern	char	*screen_start;		/* ʐ擪			*/


extern	int	show_status;		/* Xe[^X\L		*/

extern	char	*status_buf;		/* Xe[^XS 擪		*/
extern	char	*status_start[3];	/* Xe[^X` 擪		*/
extern	int	status_sx[3];		/* Xe[^X`TCY		*/
extern	int	status_sy[3];




extern	Ulong	color_pixel[16];		/* FR[h		*/
extern	Ulong	color_half_pixel[16][16];	/* F⊮̐FR[h	*/
extern	Ulong	black_pixel;			/* ̐FR[h		*/

enum {						/* Xe[^XɎgF	*/
  STATUS_BG,					/*	wiF()	*/
  STATUS_FG,					/*	OiF()	*/
  STATUS_BLACK,					/*	F		*/
  STATUS_WHITE,					/*	F		*/
  STATUS_RED,					/*	ԐF		*/
  STATUS_GREEN,					/*	ΐF		*/
  STATUS_COLOR_END
};
extern	Ulong	status_pixel[STATUS_COLOR_END];	/* Xe[^X̐FR[h	*/


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
                          WIDTH
	 
	 
	                                         
	                   
	                                   
	                   
	          SCREEN_SX                
	                                   HEIGHT
	       SCREEN_SY                   
	                                   
	                   
	                                         
	                                         
	                                         
	 
	Xe[^X0 Xe[^X1 Xe[^X2  STATUS_HEIGHT
	 

	screen_buf	`obt@ŚA擪|C^
	WIDTH		`obt@ŚAsNZ
	HEIGHT		        V          csNZ

	screen_size	ʃTCY
	screen_start	ʃobt@́A擪|C^
	SCREEN_SX	ʃobt@́AsNZ (320/640/1280)
	SCREEN_SY	      V        csNZ (200/400/800)

	DEPTH		F[x (screen_buf, screen_start ̃rbgA8/16/32)

	status_buf	Xe[^Xobt@ŚA擪|C^
	status_start[3]	Xe[^X 0`2 ̃obt@́A擪|C^
	status_sx[3]		V		      sNZ
	status_sy[3]		V		      csNZ


	 EChE\̏ꍇA
		WIDTH x (HEIGHT + STATUS_HEIGHT) ̃TCYŁA
		EChE𐶐܂B
			( Xe[^X\ȂA WIDTH x HEIGHT )

	 Sʕ\̏ꍇA
		SCREEN_SX x (SCREEN_SY + STATUS_HEIGHT) ȏ̃TCY
		Sʉ܂B
			( Xe[^X\ȂA͍̕œhԂ )

   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/


/*
 *
 */

void	draw_screen( void );
void	draw_screen_force( void );

void	draw_status( void );


void	draw_menu_screen( void );
void	draw_menu_screen_force( void );



void	blink_ctrl_update( void );	/* uÑ[NXV	*/
void	reset_frame_counter( void );

void	screen_buf_init( void );
void	status_buf_init( void );

#endif	/* SCREEN_H_INCLUDED */
